Index: c/src/lib/libcpu/powerpc/ChangeLog
===================================================================
--- c/src/lib/libcpu/powerpc/ChangeLog	(revision 88fcc6d45ac9877562b5c18403dbb3fcafab1eac)
+++ c/src/lib/libcpu/powerpc/ChangeLog	(revision 4712cdcc8d76a1a0735c126817bd6dad1277731b)
@@ -1,2 +1,7 @@
+2007-01-16 Till Straumann <strauman@slac.stanford.edu>
+
+	* mpc6xx/mmu/pte121.h, mpc6xx/mmu/pte121.c:
+	Added SLAC/Stanford Authorship Note / Copyright + Liability Disclaimer.
+
 2006-12-02	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
 
Index: c/src/lib/libcpu/powerpc/mpc6xx/mmu/pte121.c
===================================================================
--- c/src/lib/libcpu/powerpc/mpc6xx/mmu/pte121.c	(revision 88fcc6d45ac9877562b5c18403dbb3fcafab1eac)
+++ c/src/lib/libcpu/powerpc/mpc6xx/mmu/pte121.c	(revision 4712cdcc8d76a1a0735c126817bd6dad1277731b)
@@ -3,7 +3,50 @@
 /* Trivial page table setup for RTEMS
  * Purpose: allow write protection of text/ro-data
- *
- * Author: Till Straumann <strauman@slac.stanford.edu>, 4/2002
- */
+ */
+
+/* 
+ * Authorship
+ * ----------
+ * This software was created by
+ *     Till Straumann <strauman@slac.stanford.edu>, 4/2002, 2003, 2004,
+ * 	   Stanford Linear Accelerator Center, Stanford University.
+ * 
+ * Acknowledgement of sponsorship
+ * ------------------------------
+ * This software was produced by
+ *     the Stanford Linear Accelerator Center, Stanford University,
+ * 	   under Contract DE-AC03-76SFO0515 with the Department of Energy.
+ * 
+ * Government disclaimer of liability
+ * ----------------------------------
+ * Neither the United States nor the United States Department of Energy,
+ * nor any of their employees, makes any warranty, express or implied, or
+ * assumes any legal liability or responsibility for the accuracy,
+ * completeness, or usefulness of any data, apparatus, product, or process
+ * disclosed, or represents that its use would not infringe privately owned
+ * rights.
+ * 
+ * Stanford disclaimer of liability
+ * --------------------------------
+ * Stanford University makes no representations or warranties, express or
+ * implied, nor assumes any liability for the use of this software.
+ * 
+ * Stanford disclaimer of copyright
+ * --------------------------------
+ * Stanford University, owner of the copyright, hereby disclaims its
+ * copyright and all other rights in this software.  Hence, anyone may
+ * freely use it for any purpose without restriction.  
+ * 
+ * Maintenance of notices
+ * ----------------------
+ * In the interest of clarity regarding the origin and status of this
+ * SLAC software, this and all the preceding Stanford University notices
+ * are to remain affixed to any copy or derivative of this software made
+ * or distributed by the recipient and are to be affixed to any copy of
+ * software made or distributed by the recipient that contains a copy or
+ * derivative of this software.
+ * 
+ * ------------------ SLAC Software Notices, Set 4 OTT.002a, 2004 FEB 03
+ */ 
 
 /* Chose debugging options */
Index: c/src/lib/libcpu/powerpc/mpc6xx/mmu/pte121.h
===================================================================
--- c/src/lib/libcpu/powerpc/mpc6xx/mmu/pte121.h	(revision 88fcc6d45ac9877562b5c18403dbb3fcafab1eac)
+++ c/src/lib/libcpu/powerpc/mpc6xx/mmu/pte121.h	(revision 4712cdcc8d76a1a0735c126817bd6dad1277731b)
@@ -2,4 +2,49 @@
 #define _LIBCPU_PTE121_H
 /* $Id$ */
+
+/* 
+ * Authorship
+ * ----------
+ * This software was created by
+ *     Till Straumann <strauman@slac.stanford.edu>, 4/2002, 2003, 2004,
+ * 	   Stanford Linear Accelerator Center, Stanford University.
+ * 
+ * Acknowledgement of sponsorship
+ * ------------------------------
+ * This software was produced by
+ *     the Stanford Linear Accelerator Center, Stanford University,
+ * 	   under Contract DE-AC03-76SFO0515 with the Department of Energy.
+ * 
+ * Government disclaimer of liability
+ * ----------------------------------
+ * Neither the United States nor the United States Department of Energy,
+ * nor any of their employees, makes any warranty, express or implied, or
+ * assumes any legal liability or responsibility for the accuracy,
+ * completeness, or usefulness of any data, apparatus, product, or process
+ * disclosed, or represents that its use would not infringe privately owned
+ * rights.
+ * 
+ * Stanford disclaimer of liability
+ * --------------------------------
+ * Stanford University makes no representations or warranties, express or
+ * implied, nor assumes any liability for the use of this software.
+ * 
+ * Stanford disclaimer of copyright
+ * --------------------------------
+ * Stanford University, owner of the copyright, hereby disclaims its
+ * copyright and all other rights in this software.  Hence, anyone may
+ * freely use it for any purpose without restriction.  
+ * 
+ * Maintenance of notices
+ * ----------------------
+ * In the interest of clarity regarding the origin and status of this
+ * SLAC software, this and all the preceding Stanford University notices
+ * are to remain affixed to any copy or derivative of this software made
+ * or distributed by the recipient and are to be affixed to any copy of
+ * software made or distributed by the recipient that contains a copy or
+ * derivative of this software.
+ * 
+ * ------------------ SLAC Software Notices, Set 4 OTT.002a, 2004 FEB 03
+ */ 
 
 /* Rudimentary page/hash table support for Powerpc
@@ -27,5 +72,4 @@
  */
 
-/* Author: Till Straumann <strauman@slac.stanford.edu>, 4/2002 - 2004 */
 
 /* I don't include mmu.h here because it says it's derived from linux