Index: contrib/crossrpms/rtems4.10/arm/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.10/arm/Makefile.am	(revision bdd00f2a8d71d1ea1e63205fd5dd2eef179b1612)
+++ contrib/crossrpms/rtems4.10/arm/Makefile.am	(revision 04923e43e6717feeea548af0e85350d58ffe399b)
@@ -13,5 +13,5 @@
 GCC_VERS = 4.4.3
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 7
+GCC_RPMREL = 8
 
 NEWLIB_VERS = 1.18.0
Index: contrib/crossrpms/rtems4.10/avr/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.10/avr/Makefile.am	(revision bdd00f2a8d71d1ea1e63205fd5dd2eef179b1612)
+++ contrib/crossrpms/rtems4.10/avr/Makefile.am	(revision 04923e43e6717feeea548af0e85350d58ffe399b)
@@ -13,5 +13,5 @@
 GCC_VERS = 4.4.3
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 7
+GCC_RPMREL = 8
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.10/bfin/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.10/bfin/Makefile.am	(revision bdd00f2a8d71d1ea1e63205fd5dd2eef179b1612)
+++ contrib/crossrpms/rtems4.10/bfin/Makefile.am	(revision 04923e43e6717feeea548af0e85350d58ffe399b)
@@ -13,5 +13,5 @@
 GCC_VERS = 4.4.3
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 7
+GCC_RPMREL = 8
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.10/h8300/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.10/h8300/Makefile.am	(revision bdd00f2a8d71d1ea1e63205fd5dd2eef179b1612)
+++ contrib/crossrpms/rtems4.10/h8300/Makefile.am	(revision 04923e43e6717feeea548af0e85350d58ffe399b)
@@ -13,5 +13,5 @@
 GCC_VERS = 4.4.3
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 7
+GCC_RPMREL = 8
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.10/i386/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.10/i386/Makefile.am	(revision bdd00f2a8d71d1ea1e63205fd5dd2eef179b1612)
+++ contrib/crossrpms/rtems4.10/i386/Makefile.am	(revision 04923e43e6717feeea548af0e85350d58ffe399b)
@@ -13,5 +13,5 @@
 GCC_VERS = 4.4.3
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 7
+GCC_RPMREL = 8
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.10/lm32/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.10/lm32/Makefile.am	(revision bdd00f2a8d71d1ea1e63205fd5dd2eef179b1612)
+++ contrib/crossrpms/rtems4.10/lm32/Makefile.am	(revision 04923e43e6717feeea548af0e85350d58ffe399b)
@@ -13,5 +13,5 @@
 GCC_VERS = 4.4.3
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 7
+GCC_RPMREL = 8
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.10/m32c/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.10/m32c/Makefile.am	(revision bdd00f2a8d71d1ea1e63205fd5dd2eef179b1612)
+++ contrib/crossrpms/rtems4.10/m32c/Makefile.am	(revision 04923e43e6717feeea548af0e85350d58ffe399b)
@@ -13,5 +13,5 @@
 GCC_VERS = 4.4.3
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 7
+GCC_RPMREL = 8
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.10/m32r/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.10/m32r/Makefile.am	(revision bdd00f2a8d71d1ea1e63205fd5dd2eef179b1612)
+++ contrib/crossrpms/rtems4.10/m32r/Makefile.am	(revision 04923e43e6717feeea548af0e85350d58ffe399b)
@@ -13,5 +13,5 @@
 GCC_VERS = 4.4.3
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 7
+GCC_RPMREL = 8
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.10/m68k/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.10/m68k/Makefile.am	(revision bdd00f2a8d71d1ea1e63205fd5dd2eef179b1612)
+++ contrib/crossrpms/rtems4.10/m68k/Makefile.am	(revision 04923e43e6717feeea548af0e85350d58ffe399b)
@@ -13,5 +13,5 @@
 GCC_VERS = 4.4.3
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 7
+GCC_RPMREL = 8
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.10/mips/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.10/mips/Makefile.am	(revision bdd00f2a8d71d1ea1e63205fd5dd2eef179b1612)
+++ contrib/crossrpms/rtems4.10/mips/Makefile.am	(revision 04923e43e6717feeea548af0e85350d58ffe399b)
@@ -13,5 +13,5 @@
 GCC_VERS = 4.4.3
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 7
+GCC_RPMREL = 8
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.10/powerpc/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.10/powerpc/Makefile.am	(revision bdd00f2a8d71d1ea1e63205fd5dd2eef179b1612)
+++ contrib/crossrpms/rtems4.10/powerpc/Makefile.am	(revision 04923e43e6717feeea548af0e85350d58ffe399b)
@@ -13,5 +13,5 @@
 GCC_VERS = 4.4.3
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 7
+GCC_RPMREL = 8
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.10/sh/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.10/sh/Makefile.am	(revision bdd00f2a8d71d1ea1e63205fd5dd2eef179b1612)
+++ contrib/crossrpms/rtems4.10/sh/Makefile.am	(revision 04923e43e6717feeea548af0e85350d58ffe399b)
@@ -13,5 +13,5 @@
 GCC_VERS = 4.4.3
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 7
+GCC_RPMREL = 8
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)
Index: contrib/crossrpms/rtems4.10/sparc/Makefile.am
===================================================================
--- contrib/crossrpms/rtems4.10/sparc/Makefile.am	(revision bdd00f2a8d71d1ea1e63205fd5dd2eef179b1612)
+++ contrib/crossrpms/rtems4.10/sparc/Makefile.am	(revision 04923e43e6717feeea548af0e85350d58ffe399b)
@@ -13,5 +13,5 @@
 GCC_VERS = 4.4.3
 GCC_PKGVERS = $(GCC_VERS)
-GCC_RPMREL = 7
+GCC_RPMREL = 8
 NEWLIB_VERS = 1.18.0
 NEWLIB_PKGVERS = $(NEWLIB_VERS)