Index: c/src/lib/libbsp/powerpc/ep1a/ChangeLog
===================================================================
--- c/src/lib/libbsp/powerpc/ep1a/ChangeLog	(revision 90b68014babfcd2f073c1174ee3b7d378002b309)
+++ c/src/lib/libbsp/powerpc/ep1a/ChangeLog	(revision 5134f17201acd71b4d458b5e24cfd284ed1f46c1)
@@ -1,2 +1,8 @@
+2011-02-11	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
+
+	* console/console.c, console/ns16550cfg.c, console/polled_io.c,
+	include/bsp.h, include/tm27.h, startup/bspstart.c:
+	Use "__asm__" instead of "asm" for improved c99-compliance.
+
 2011-02-02	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
 
Index: c/src/lib/libbsp/powerpc/ep1a/console/console.c
===================================================================
--- c/src/lib/libbsp/powerpc/ep1a/console/console.c	(revision 90b68014babfcd2f073c1174ee3b7d378002b309)
+++ c/src/lib/libbsp/powerpc/ep1a/console/console.c	(revision 5134f17201acd71b4d458b5e24cfd284ed1f46c1)
@@ -260,10 +260,10 @@
   if ('\n'==c){
      *ptr = '\r';
-     asm volatile("sync");
+     __asm__ volatile("sync");
      for (i=0;i<0x0fff;i++);
   }
 
   *ptr = c;
-  asm volatile("sync");
+  __asm__ volatile("sync");
   for (i=0;i<0x0fff;i++);
 }
Index: c/src/lib/libbsp/powerpc/ep1a/console/ns16550cfg.c
===================================================================
--- c/src/lib/libbsp/powerpc/ep1a/console/ns16550cfg.c	(revision 90b68014babfcd2f073c1174ee3b7d378002b309)
+++ c/src/lib/libbsp/powerpc/ep1a/console/ns16550cfg.c	(revision 5134f17201acd71b4d458b5e24cfd284ed1f46c1)
@@ -30,5 +30,5 @@
   uint8_t  ucData;
   ucData = p[ucRegNum].reg;
-  asm volatile("sync");
+  __asm__ volatile("sync");
   return ucData;
 }
@@ -43,8 +43,8 @@
   volatile int i;
   p[ucRegNum].reg = ucData;
-  asm volatile("sync");
-  asm volatile("isync");
-  asm volatile("eieio");
+  __asm__ volatile("sync");
+  __asm__ volatile("isync");
+  __asm__ volatile("eieio");
   for (i=0;i<0x08ff;i++)
-    asm volatile("isync");
+    __asm__ volatile("isync");
 }
Index: c/src/lib/libbsp/powerpc/ep1a/console/polled_io.c
===================================================================
--- c/src/lib/libbsp/powerpc/ep1a/console/polled_io.c	(revision 90b68014babfcd2f073c1174ee3b7d378002b309)
+++ c/src/lib/libbsp/powerpc/ep1a/console/polled_io.c	(revision 5134f17201acd71b4d458b5e24cfd284ed1f46c1)
@@ -926,5 +926,5 @@
 #define div10(num, rmd)							 \
 do {	u32 t1, t2, t3;							 \
-	asm("lis %4,0xcccd; "						 \
+	__asm__ ("lis %4,0xcccd; "						 \
 	    "addi %4,%4,0xffffcccd; "	/* Build 0xcccccccd */		 \
 	    "mulhwu %3,%0+1,%4; "	/* (num.l*cst.l).h  */		 \
Index: c/src/lib/libbsp/powerpc/ep1a/include/bsp.h
===================================================================
--- c/src/lib/libbsp/powerpc/ep1a/include/bsp.h	(revision 90b68014babfcd2f073c1174ee3b7d378002b309)
+++ c/src/lib/libbsp/powerpc/ep1a/include/bsp.h	(revision 5134f17201acd71b4d458b5e24cfd284ed1f46c1)
@@ -175,5 +175,5 @@
 
 #define Processor_Synchronize() \
-  asm(" eieio ")
+  __asm__ (" eieio ")
 
 extern void BSP_panic(char *s);
Index: c/src/lib/libbsp/powerpc/ep1a/include/tm27.h
===================================================================
--- c/src/lib/libbsp/powerpc/ep1a/include/tm27.h	(revision 90b68014babfcd2f073c1174ee3b7d378002b309)
+++ c/src/lib/libbsp/powerpc/ep1a/include/tm27.h	(revision 5134f17201acd71b4d458b5e24cfd284ed1f46c1)
@@ -40,5 +40,5 @@
   do { \
     uint32_t _clicks = 8; \
-    asm volatile( "mtdec %0" : "=r" ((_clicks)) : "r" ((_clicks)) ); \
+    __asm__ volatile( "mtdec %0" : "=r" ((_clicks)) : "r" ((_clicks)) ); \
   } while (0)
 
@@ -47,5 +47,5 @@
   do { \
     uint32_t _clicks = 0xffffffff; \
-    asm volatile( "mtdec %0" : "=r" ((_clicks)) : "r" ((_clicks)) ); \
+    __asm__ volatile( "mtdec %0" : "=r" ((_clicks)) : "r" ((_clicks)) ); \
    } while (0)
 
@@ -54,7 +54,7 @@
     uint32_t _msr = 0; \
     _ISR_Set_level( 0 ); \
-    asm volatile( "mfmsr %0 ;" : "=r" (_msr) : "r" (_msr) ); \
+    __asm__ volatile( "mfmsr %0 ;" : "=r" (_msr) : "r" (_msr) ); \
     _msr |=  0x8002; \
-    asm volatile( "mtmsr %0 ;" : "=r" (_msr) : "r" (_msr) ); \
+    __asm__ volatile( "mtmsr %0 ;" : "=r" (_msr) : "r" (_msr) ); \
   } while (0)
 #endif
Index: c/src/lib/libbsp/powerpc/ep1a/startup/bspstart.c
===================================================================
--- c/src/lib/libbsp/powerpc/ep1a/startup/bspstart.c	(revision 90b68014babfcd2f073c1174ee3b7d378002b309)
+++ c/src/lib/libbsp/powerpc/ep1a/startup/bspstart.c	(revision 5134f17201acd71b4d458b5e24cfd284ed1f46c1)
@@ -185,16 +185,16 @@
   register int a, e;
 
-  asm volatile( "lis %0,0xfec0; ori  %0,%0,0x0000": "=r" (a) );
-  asm volatile("sync");
-
-  asm volatile("lis %0,0x8000; ori %0,%0,0x0078": "=r"(e) );
-  asm volatile("stwbrx  %0,0x0,%1": "=r"(e): "r"(a));
-  asm volatile("sync");
-
-  asm volatile("lis %0,0xfee0; ori %0,%0,0x0000": "=r" (a) );
-  asm volatile("sync");
-
-  asm volatile("lwbrx %0,0x0,%1": "=r" (e): "r" (a));
-  asm volatile("isync");
+  __asm__ volatile( "lis %0,0xfec0; ori  %0,%0,0x0000": "=r" (a) );
+  __asm__ volatile("sync");
+
+  __asm__ volatile("lis %0,0x8000; ori %0,%0,0x0078": "=r"(e) );
+  __asm__ volatile("stwbrx  %0,0x0,%1": "=r"(e): "r"(a));
+  __asm__ volatile("sync");
+
+  __asm__ volatile("lis %0,0xfee0; ori %0,%0,0x0000": "=r" (a) );
+  __asm__ volatile("sync");
+
+  __asm__ volatile("lwbrx %0,0x0,%1": "=r" (e): "r" (a));
+  __asm__ volatile("isync");
   return e;
 }