Index: cpukit/librpc/src/rpc/clnt_raw.c
===================================================================
--- cpukit/librpc/src/rpc/clnt_raw.c	(revision ddb56f497d21aa84cf3311ac665744243cd627a0)
+++ cpukit/librpc/src/rpc/clnt_raw.c	(revision 5220ae2f71bd24ceb4863375f037bfb27bf8d80d)
@@ -85,7 +85,7 @@
  */
 CLIENT *
-clntraw_create(prog, vers)
-	u_long prog;
-	u_long vers;
+clntraw_create(
+	u_long prog,
+	u_long vers )
 {
 	register struct clnt_raw_private *clp = clntraw_private;
@@ -128,12 +128,12 @@
 
 static enum clnt_stat
-clntraw_call(h, proc, xargs, argsp, xresults, resultsp, timeout)
-	CLIENT *h;
-	u_long proc;
-	xdrproc_t xargs;
-	caddr_t argsp;
-	xdrproc_t xresults;
-	caddr_t resultsp;
-	struct timeval timeout;
+clntraw_call(
+	CLIENT *h,
+	u_long proc,
+	xdrproc_t xargs,
+	caddr_t argsp,
+	xdrproc_t xresults,
+	caddr_t resultsp,
+	struct timeval timeout )
 {
 	register struct clnt_raw_private *clp = clntraw_private;
@@ -209,8 +209,8 @@
 
 static bool_t
-clntraw_freeres(cl, xdr_res, res_ptr)
-	CLIENT *cl;
-	xdrproc_t xdr_res;
-	caddr_t res_ptr;
+clntraw_freeres(
+	CLIENT *cl,
+	xdrproc_t xdr_res,
+	caddr_t res_ptr )
 {
 	register struct clnt_raw_private *clp = clntraw_private;
Index: cpukit/librpc/src/rpc/rpcdname.c
===================================================================
--- cpukit/librpc/src/rpc/rpcdname.c	(revision ddb56f497d21aa84cf3311ac665744243cd627a0)
+++ cpukit/librpc/src/rpc/rpcdname.c	(revision 5220ae2f71bd24ceb4863375f037bfb27bf8d80d)
@@ -55,6 +55,6 @@
 	if (getdomainname(temp, sizeof(temp)) < 0)
 		return (0);
-	if ((int) strlen(temp) > 0) {
-		default_domain = (char *)malloc((strlen(temp)+(unsigned)1));
+	if (strlen(temp) > 0) {
+		default_domain = (char *)malloc((strlen(temp)+(size_t)1));
 		if (default_domain == 0)
 			return (0);
@@ -72,6 +72,6 @@
  */
 int
-_rpc_get_default_domain(domain)
-	char **domain;
+_rpc_get_default_domain(
+	char **domain )
 {
 	if ((*domain = get_default_domain()) != 0)
Index: cpukit/librpc/src/rpc/rtems_portmapper.c
===================================================================
--- cpukit/librpc/src/rpc/rtems_portmapper.c	(revision ddb56f497d21aa84cf3311ac665744243cd627a0)
+++ cpukit/librpc/src/rpc/rtems_portmapper.c	(revision 5220ae2f71bd24ceb4863375f037bfb27bf8d80d)
@@ -78,5 +78,5 @@
 	}
 	/* make an entry for ourself */
-	pml = (struct pmaplist *)malloc((u_int)sizeof(struct pmaplist));
+	pml = (struct pmaplist *)malloc(sizeof(struct pmaplist));
 	pml->pml_next = 0;
 	pml->pml_map.pm_prog = PMAPPROG;
@@ -103,5 +103,5 @@
 	}
 	/* make an entry for ourself */
-	pml = (struct pmaplist *)malloc((u_int)sizeof(struct pmaplist));
+	pml = (struct pmaplist *)malloc(sizeof(struct pmaplist));
 	pml->pml_map.pm_prog = PMAPPROG;
 	pml->pml_map.pm_vers = PMAPVERS;
@@ -120,7 +120,8 @@
 
 static struct pmaplist *
-find_service(prog, vers, prot)
-u_long prog;
-u_long vers;
+find_service(
+  u_long prog,
+  u_long vers,
+  int prot )
 {
 register struct pmaplist *hit = NULL;
@@ -141,7 +142,7 @@
  * 1 OK, 0 not
  */
-static void reg_service(rqstp, xprt)
-	struct svc_req *rqstp;
-	SVCXPRT *xprt;
+static void reg_service(
+	struct svc_req *rqstp,
+	SVCXPRT *xprt )
 {
 	struct pmap reg;
@@ -191,5 +192,5 @@
 				 */
 				pml = (struct pmaplist *)
-				    malloc((u_int)sizeof(struct pmaplist));
+				    malloc(sizeof(struct pmaplist));
 				pml->pml_map = reg;
 				pml->pml_next = 0;
@@ -310,7 +311,7 @@
 
 static bool_t
-xdr_encap_parms(xdrs, epp)
-	XDR *xdrs;
-	struct encap_parms *epp;
+xdr_encap_parms(
+	XDR *xdrs,
+	struct encap_parms *epp )
 {
 
@@ -327,7 +328,7 @@
 
 static bool_t
-xdr_rmtcall_args(xdrs, cap)
-	register XDR *xdrs;
-	register struct rmtcallargs *cap;
+xdr_rmtcall_args(
+	register XDR *xdrs,
+	register struct rmtcallargs *cap )
 {
 
@@ -342,7 +343,7 @@
 
 static bool_t
-xdr_rmtcall_result(xdrs, cap)
-	register XDR *xdrs;
-	register struct rmtcallargs *cap;
+xdr_rmtcall_result(
+	register XDR *xdrs,
+	register struct rmtcallargs *cap )
 {
 	if (xdr_u_long(xdrs, &(cap->rmt_port)))
@@ -356,7 +357,7 @@
  */
 static bool_t
-xdr_opaque_parms(xdrs, cap)
-	XDR *xdrs;
-	struct rmtcallargs *cap;
+xdr_opaque_parms(
+	XDR *xdrs,
+	struct rmtcallargs *cap )
 {
 
@@ -369,7 +370,7 @@
  */
 static bool_t
-xdr_len_opaque_parms(xdrs, cap)
-	register XDR *xdrs;
-	struct rmtcallargs *cap;
+xdr_len_opaque_parms(
+	register XDR *xdrs,
+	struct rmtcallargs *cap )
 {
 	register u_int beginpos, lowpos, highpos, currpos, pos;
@@ -402,7 +403,7 @@
  */
 static void
-callit(rqstp, xprt)
-	struct svc_req *rqstp;
-	SVCXPRT *xprt;
+callit(
+	struct svc_req *rqstp,
+	SVCXPRT *xprt )
 {
 	struct rmtcallargs a;
Index: cpukit/librpc/src/rpc/svc.c
===================================================================
--- cpukit/librpc/src/rpc/svc.c	(revision ddb56f497d21aa84cf3311ac665744243cd627a0)
+++ cpukit/librpc/src/rpc/svc.c	(revision 5220ae2f71bd24ceb4863375f037bfb27bf8d80d)
@@ -80,6 +80,6 @@
  */
 void
-xprt_register(xprt)
-	SVCXPRT *xprt;
+xprt_register(
+	SVCXPRT *xprt )
 {
 	register int sock = xprt->xp_sock;
@@ -126,6 +126,6 @@
  */
 void
-xprt_unregister(xprt)
-	SVCXPRT *xprt;
+xprt_unregister(
+	SVCXPRT *xprt )
 {
 	register int sock = xprt->xp_sock;
@@ -157,10 +157,10 @@
  */
 bool_t
-svc_register(xprt, prog, vers, dispatch, protocol)
-	SVCXPRT *xprt;
-	u_long prog;
-	u_long vers;
-	void (*dispatch)();
-	int protocol;
+svc_register(
+	SVCXPRT *xprt,
+	u_long prog,
+	u_long vers,
+	void (*dispatch)(),
+	int protocol )
 {
 	struct svc_callout *prev;
@@ -193,7 +193,7 @@
  */
 void
-svc_unregister(prog, vers)
-	u_long prog;
-	u_long vers;
+svc_unregister(
+	u_long prog,
+	u_long vers )
 {
 	struct svc_callout *prev;
@@ -218,8 +218,8 @@
  */
 static struct svc_callout *
-svc_find(prog, vers, prev)
-	u_long prog;
-	u_long vers;
-	struct svc_callout **prev;
+svc_find(
+	u_long prog,
+	u_long vers,
+	struct svc_callout **prev )
 {
 	register struct svc_callout *s, *p;
@@ -242,8 +242,8 @@
  */
 bool_t
-svc_sendreply(xprt, xdr_results, xdr_location)
-	register SVCXPRT *xprt;
-	xdrproc_t xdr_results;
-	caddr_t xdr_location;
+svc_sendreply(
+	register SVCXPRT *xprt,
+	xdrproc_t xdr_results,
+	caddr_t xdr_location )
 {
 	struct rpc_msg rply;
@@ -262,6 +262,6 @@
  */
 void
-svcerr_noproc(xprt)
-	register SVCXPRT *xprt;
+svcerr_noproc(
+	register SVCXPRT *xprt )
 {
 	struct rpc_msg rply;
@@ -278,6 +278,6 @@
  */
 void
-svcerr_decode(xprt)
-	register SVCXPRT *xprt;
+svcerr_decode(
+	register SVCXPRT *xprt )
 {
 	struct rpc_msg rply;
@@ -294,6 +294,6 @@
  */
 void
-svcerr_systemerr(xprt)
-	register SVCXPRT *xprt;
+svcerr_systemerr(
+	register SVCXPRT *xprt )
 {
 	struct rpc_msg rply;
@@ -310,7 +310,7 @@
  */
 void
-svcerr_auth(xprt, why)
-	SVCXPRT *xprt;
-	enum auth_stat why;
+svcerr_auth(
+	SVCXPRT *xprt,
+	enum auth_stat why )
 {
 	struct rpc_msg rply;
@@ -327,6 +327,6 @@
  */
 void
-svcerr_weakauth(xprt)
-	SVCXPRT *xprt;
+svcerr_weakauth(
+	SVCXPRT *xprt )
 {
 
@@ -338,6 +338,6 @@
  */
 void
-svcerr_noprog(xprt)
-	register SVCXPRT *xprt;
+svcerr_noprog(
+	register SVCXPRT *xprt )
 {
 	struct rpc_msg rply;
@@ -354,8 +354,8 @@
  */
 void
-svcerr_progvers(xprt, low_vers, high_vers)
-	register SVCXPRT *xprt;
-	u_long low_vers;
-	u_long high_vers;
+svcerr_progvers(
+	register SVCXPRT *xprt,
+	u_long low_vers,
+	u_long high_vers )
 {
 	struct rpc_msg rply;
@@ -389,6 +389,6 @@
 
 void
-svc_getreq(rdfds)
-	int rdfds;
+svc_getreq(
+	int rdfds )
 {
 	fd_set readfds;
@@ -400,6 +400,6 @@
 
 void
-svc_getreqset(readfds)
-	fd_set *readfds;
+svc_getreqset(
+	fd_set *readfds )
 {
 	svc_getreqset2(readfds, FD_SETSIZE);
@@ -407,7 +407,7 @@
 
 void
-svc_getreqset2(readfds, width)
-	fd_set *readfds;
-	int width;
+svc_getreqset2(
+	fd_set *readfds,
+	int width )
 {
 	enum xprt_stat stat;
Index: cpukit/librpc/src/rpc/svc_simple.c
===================================================================
--- cpukit/librpc/src/rpc/svc_simple.c	(revision ddb56f497d21aa84cf3311ac665744243cd627a0)
+++ cpukit/librpc/src/rpc/svc_simple.c	(revision 5220ae2f71bd24ceb4863375f037bfb27bf8d80d)
@@ -62,8 +62,11 @@
 
 int
-registerrpc(prognum, versnum, procnum, progname, inproc, outproc)
-	int prognum, versnum, procnum;
-	char *(*progname)();
-	xdrproc_t inproc, outproc;
+registerrpc(
+	int prognum,
+	int versnum,
+	int procnum,
+	char *(*progname)(),
+	xdrproc_t inproc,
+	xdrproc_t outproc )
 {
 
@@ -103,7 +106,7 @@
 
 static void
-universal(rqstp, atransp)
-	struct svc_req *rqstp;
-	SVCXPRT *atransp;
+universal(
+	struct svc_req *rqstp,
+	SVCXPRT *atransp )
 {
 	int prog, proc;